package se.gu.spraakbanken.saldo;

import javax.swing.JTextField;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Color;
import java.io.IOException;
import java.net.URL;

public class SaldoCompleter extends KeyAdapter {

    private static SimpleSaldoLexicon saldo = null;

    private JTextField tf;

    public SaldoCompleter(JTextField tf) {
        this.tf = tf;
    }

    public static void loadSaldo(String saldoFile) throws IOException {
        saldo = new SimpleSaldoLexicon(saldoFile);
    }
    
    public static void loadSaldo(URL saldoURL) throws IOException {
        loadSaldo(saldoURL.getFile());
    }

    
    /*
     * @Override public void keyTyped(KeyEvent e) { }
     */

    private SimpleSaldoLexicon.Index ix;
    
    public void keyReleased(KeyEvent e) {
        if(saldo == null)
            return;
        switch (e.getKeyCode()) {
        case KeyEvent.VK_UP: {
            int pos = tf.getCaretPosition();
            if(ix == null)
                ix = saldo.byPrefix(tf.getText());
            SimpleSaldoLexicon.Index previous = saldo.previous(ix);
            if (previous == null)
                return;
            ix = previous;
            tf.setText(previous.s);
            tf.setCaretPosition(pos);
            tf.setForeground(Color.BLACK);
        }
            break;
        case KeyEvent.VK_DOWN: {
            int pos = tf.getCaretPosition();
            if(ix == null)
                ix = saldo.byPrefix(tf.getText());
             SimpleSaldoLexicon.Index next = saldo.next(ix);
            if (next == null)
                return;
            ix = next;
            tf.setText(next.s);
            tf.setCaretPosition(pos);
            tf.setForeground(Color.BLACK);
        }
            break;
        case KeyEvent.VK_LEFT:
            break;
        case KeyEvent.VK_RIGHT:
            break;
        case KeyEvent.VK_HOME:
            break;
        case KeyEvent.VK_END:
            break;
        default: {
            String s = tf.getText();
            int pos = tf.getCaretPosition();
            String pfx = s.substring(0, pos);
            ix = saldo.byPrefix(pfx);
            if (ix != null) {
                tf.setText(ix.s);
                tf.setCaretPosition(pos);
                tf.setForeground(Color.BLACK);
            } else {
                tf.setForeground(Color.RED);
            }
        }
        }

    }


    /*
     * @Override public void keyReleased(KeyEvent e) { }
     */

}
